#include "tof_hw.h"


sfr sbit TOF_DRDY at RE8_bit;
sfr sbit TOF_DRDY_DIR at TRISE8_bit;
sfr sbit TOF_ENABLE at RC1_bit;
sfr sbit TOF_ENABLE_DIR at TRISC1_bit;

uint64_t milliseconds_counter;

void timer_setup()
{
  T1CON                 = 0x8010;
  T1IP0_bit         = 1;
  T1IP1_bit         = 1;
  T1IP2_bit         = 1;
  T1IF_bit         = 0;
  T1IE_bit         = 1;
  PR1                 = 10000;
  TMR1                 = 0;
  EnableInterrupts();
}


void mcu_setup()
{

  TOF_DRDY_DIR = 1;
  TOF_ENABLE_DIR = 0;

  TOF_ENABLE = 0;
  delay_ms(100);
  I2C2_Init( 100000 );
  delay_ms(200);
  tof_hal_init();
  TOF_ENABLE = 1;
  delay_ms(100);
  Uart5_Init(57600);
  delay_ms(200);
  Uart_Write_Text("Uart init\r\n");

}

uint8_t testread[3];
uint16_t model_id;
uint16_t range;

void main()
{
     char txt[10];
     AD1PCFG = 0xFFFF;



     mcu_setup();
     model_id = tof_read_reg_16Bit(IDENTIFICATION_MODEL_ID);
     timer_setup();

     tof_init(true);
     tof_set_timeout(500);
     tof_start_continuous(0);
     Uart_Write_Text("TOF ready\r\n");



     while(1)
     {
        range = tof_read_range_continuous_millimeters();
        WordToStr(range, txt);
        Uart_Write_Text("Range: ");
        Uart_Write_Text(txt);
        Uart_Write_Text("\r\n");

        if (tof_timeout_occurred())
           Uart_Write_Text("TIMEOUT\r\n");

     }


}


void Timer1Interrupt() iv IVT_TIMER_1 ilevel 7 ics ICS_SRS
{
  T1IF_bit         = 0;
  milliseconds_counter++;
}